clang 10.0.0git

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
clang::GeneratePCHAction Class Reference

`#include "clang/Frontend/FrontendActions.h"`

Inheritance diagram for clang::GeneratePCHAction:
[legend]
Collaboration diagram for clang::GeneratePCHAction:
[legend]

## Public Member Functions
bool | BeginSourceFileAction (CompilerInstance &CI) override
| Callback at the start of processing a single input. More...
Public Member Functions inherited from clang::ASTFrontendAction
| ASTFrontendAction ()
bool | usesPreprocessorOnly () const override
| Does this action only use the preprocessor? More...
Public Member Functions inherited from clang::FrontendAction
| FrontendAction ()
virtual | ~FrontendAction ()
CompilerInstance & | getCompilerInstance () const
void | setCompilerInstance (CompilerInstance *Value)
bool | isCurrentFileAST () const
const FrontendInputFile & | getCurrentInput () const
StringRef | getCurrentFile () const
StringRef | getCurrentFileOrBufferName () const
InputKind | getCurrentFileKind () const
ASTUnit & | getCurrentASTUnit () const
Module * | getCurrentModule () const
std::unique_ptr< ASTUnit > | takeCurrentASTUnit ()
void | setCurrentInput (const FrontendInputFile &CurrentInput, std::unique_ptr< ASTUnit > AST=nullptr)
virtual bool | isModelParsingAction () const
| Is this action invoked on a model file? More...
virtual bool | hasPCHSupport () const
| Does this action support use with PCH? More...
virtual bool | hasIRSupport () const
| Does this action support use with IR files? More...
virtual bool | hasCodeCompletionSupport () const
| Does this action support use with code completion? More...
bool | PrepareToExecute (CompilerInstance &CI)
| Prepare the action to execute on the given compiler instance. More...
bool | BeginSourceFile (CompilerInstance &CI, const FrontendInputFile &Input)
| Prepare the action for processing the input file `Input`. More...
llvm::Error | Execute ()
| Set the source manager's main input file, and run the action. More...
void | EndSourceFile ()
| Perform any per-file post processing, deallocate per-file objects, and run statistics and output file cleanup code. More...

## Static Public Member Functions
static bool | ComputeASTConsumerArguments (CompilerInstance &CI, std::string &Sysroot)
| Compute the AST consumer arguments that will be used to create the PCHGenerator instance returned by CreateASTConsumer. More...
static std::unique_ptr< llvm::raw_pwrite_stream > | CreateOutputFile (CompilerInstance &CI, StringRef InFile, std::string &OutputFile)
| Creates file to write the PCH into and returns a stream to write it into. More...

## Protected Member Functions
std::unique_ptr< ASTConsumer > | CreateASTConsumer (CompilerInstance &CI, StringRef InFile) override
| Create the AST consumer object for this action, if supported. More...
TranslationUnitKind | getTranslationUnitKind () override
| For AST-based actions, the kind of translation unit we're handling. More...
bool | hasASTFileSupport () const override
| Does this action support use with AST files? More...
bool | shouldEraseOutputFiles () override
| Callback at the end of processing a single input, to determine if the output files should be erased or not. More...
Protected Member Functions inherited from clang::ASTFrontendAction
void | ExecuteAction () override
| Implement the ExecuteAction interface by running Sema on the already-initialized AST consumer. More...
Protected Member Functions inherited from clang::FrontendAction
virtual bool | PrepareToExecuteAction (CompilerInstance &CI)
| Prepare to execute the action on the given CompilerInstance. More...
virtual bool | BeginInvocation (CompilerInstance &CI)
| Callback before starting processing a single input, giving the opportunity to modify the CompilerInvocation or do some other action before BeginSourceFileAction is called. More...
virtual void | EndSourceFileAction ()
| Callback at the end of processing a single input. More...

## Detailed Description

Definition at line 77 of file FrontendActions.h.

## Member Function Documentation

## ◆ BeginSourceFileAction()

bool GeneratePCHAction::BeginSourceFileAction | ( | CompilerInstance & | CI | ) |
| override virtual

Callback at the start of processing a single input.

Returns
  True on success; on failure ExecutionAction() and EndSourceFileAction() will not be called.

Reimplemented from clang::FrontendAction.

Definition at line 157 of file FrontendActions.cpp.

References clang::CompilerInstance::getLangOpts().

## ◆ ComputeASTConsumerArguments()

bool GeneratePCHAction::ComputeASTConsumerArguments | ( | CompilerInstance & | CI,
|  | std::string & | Sysroot
| ) |  |
| static

Compute the AST consumer arguments that will be used to create the PCHGenerator instance returned by CreateASTConsumer.

Returns
  false if an error occurred, true otherwise.

Definition at line 123 of file FrontendActions.cpp.

References clang::CompilerInstance::getDiagnostics(), clang::CompilerInstance::getFrontendOpts(), clang::CompilerInstance::getHeaderSearchOpts(), clang::FrontendOptions::RelocatablePCH, clang::DiagnosticsEngine::Report(), and clang::HeaderSearchOptions::Sysroot.

## ◆ CreateASTConsumer()

std::unique_ptr< ASTConsumer > GeneratePCHAction::CreateASTConsumer | ( | CompilerInstance & | CI,
|  | StringRef | InFile
| ) |  |
| override protected virtual

Create the AST consumer object for this action, if supported.

This routine is called as part of BeginSourceFile(), which will fail if the AST consumer cannot be created. This will not be called if the action has indicated that it only uses the preprocessor.

Parameters

  CI | - The current compiler instance, provided as a convenience, see getCompilerInstance().
  InFile | - The current input file, provided as a convenience, see getCurrentFile().

Returns
  The new AST consumer, or null on failure.

Implements clang::FrontendAction.

Definition at line 95 of file FrontendActions.cpp.

References clang::PreprocessorOptions::AllowPCHWithCompilerErrors, clang::PCHContainerWriter::CreatePCHContainerGenerator(), clang::CompilerInstance::getFrontendOpts(), clang::CompilerInstance::getLangOpts(), clang::CompilerInstance::getModuleCache(), clang::CompilerInstance::getPCHContainerWriter(), clang::CompilerInstance::getPreprocessor(), clang::CompilerInstance::getPreprocessorOpts(), and clang::FrontendOptions::RelocatablePCH.

## ◆ CreateOutputFile()

std::unique_ptr< llvm::raw_pwrite_stream > GeneratePCHAction::CreateOutputFile | ( | CompilerInstance & | CI,
|  | StringRef | InFile,
|  | std::string & | OutputFile
| ) |  |
| static

Creates file to write the PCH into and returns a stream to write it into.

On error, returns null.

Definition at line 135 of file FrontendActions.cpp.

References clang::CompilerInstance::createOutputFile(), clang::CompilerInstance::getFrontendOpts(), clang::FrontendOptions::OutputFile, and clang::FrontendOptions::UseTemporary.

## ◆ getTranslationUnitKind()

TranslationUnitKind clang::GeneratePCHAction::getTranslationUnitKind | ( |  | ) |
| inline override protected virtual

For AST-based actions, the kind of translation unit we're handling.

Reimplemented from clang::FrontendAction.

Definition at line 82 of file FrontendActions.h.

References clang::TU_Prefix.

## ◆ hasASTFileSupport()

bool clang::GeneratePCHAction::hasASTFileSupport | ( |  | ) | const
| inline override protected virtual

Does this action support use with AST files?

Reimplemented from clang::FrontendAction.

Definition at line 86 of file FrontendActions.h.

References clang::FrontendAction::BeginSourceFileAction(), and clang::FrontendAction::shouldEraseOutputFiles().

## ◆ shouldEraseOutputFiles()

bool GeneratePCHAction::shouldEraseOutputFiles | ( |  | ) |
| override protected virtual

Callback at the end of processing a single input, to determine if the output files should be erased or not.

By default it returns true if a compiler error occurred. This is guaranteed to only be called following a successful call to BeginSourceFileAction (and BeginSourceFile).

Reimplemented from clang::FrontendAction.

Definition at line 151 of file FrontendActions.cpp.

References clang::FrontendAction::getCompilerInstance(), and clang::FrontendAction::shouldEraseOutputFiles().

The documentation for this class was generated from the following files:

- include/clang/Frontend/FrontendActions.h
- lib/Frontend/FrontendActions.cpp